/********************************************************************
Copyright (C), 2005, eView HMItek (Shanghai) Ltd.
All rights reserved.

FileName: plc_driver.c
Description:  PLC driver interface
MODBUS RTUЭ


Revision history:         
<author>  <time>   <version >   <desc>
maxt    2005/3/30   0.1         build this program
tiansm  2005/4/26   1.0         finish this program
tiansm  2005.8.16	1.1         ޸ݵĴ뷽ʽ,lengthʵʵĳǺ
tiansm  2005.10.24  1.2         ev_plc_slave_mainڴ빲ڴLB,LWָʵִ豸
tiansm  2005.11.30  1.3         ޸ȫֳʱжϷʽ
YuLi    2008.4.17   1.4         ȥev_plc_slave_mainreturnev_plc_slave_mainвӦreturn
maxt  2008.4.19    1.5         д15дλԪǰȫԡ
maxt  2008.6.6     1.6        дʱжϣóжϺͳʱϣʱµվŵĴ֡վ
						ϲӦʱ⡣ʱʱ䲻1.5
********************************************************************/
#include      "plc_driver.h"
#include <stdio.h>      /*׼*/
#include <stdlib.h>     /*׼ⶨ*/
#include <unistd.h>     /*Unix ׼*/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>      /*ļƶ*/
#include     <errno.h>      /*Ŷ*/
#include 	 <sys/time.h> 
#include	 <time.h>
#include     <stdbool.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>

/**
*@brief  ôͨ
*@param  fd      int  򿪴ڵļ
*@param  speed   int  ٶ
*@return  void
*/

#define LW_addr(n)   (local_short+(n))
#define LW_WRITE_NUM_MAX 9000
#define LW_READ_NUM_MAX 10000
#define LW_WRITE_MAX 8999
#define LB_WRITE_MAX 8999
#define LW_READ_MAX 9999
#define LB_READ_MAX 9999
int globle_semid;
short *local_short=NULL;
int *globle_local_bit=NULL;




unsigned int ev_plc_init( PLC_SERIAL_INIT_PARAMETERS * serial_settings,PLC_DRV_INIT_SETTINGS * settings)
{
//		int fd;	
//		int parity_bit;
//		fd = OpenDev(serial_settings->com_device);
//		settings->serial_handle=fd;//򿪴ڵķֵ
//		set_speed(fd,serial_settings->baud);//ò	
//		//λֹͣλУλ
//		if (set_Parity(fd,serial_settings->data_bits,serial_settings->stop_bits,serial_settings->parity) == -1)
//		{
//			printf("Set Parity Error\n");
//			exit (0);
//		}
//		//Уλ
//		if(serial_settings->parity==0)
//			parity_bit=0;//У
//		else
//			parity_bit=1;//桢żУ
//		settings->timeout1=1.5*1000000*( 1 + serial_settings->data_bits + serial_settings->parity + serial_settings->stop_bits)/serial_settings->baud;
//		//settings->timeout1=settings->timeout1+set_adjust_time_bps(serial_settings->baud)+settings->timeout2*1000;
//		//settings->timeout1=settings->timeout2*1000;
}

unsigned int ev_plc_read ( PLC_DRV_REG_ADDR * reg_addr , PLC_DRV_BUFF * buff ,  PLC_DRV_INIT_SETTINGS * settings)
{
	return 0;
}

int write_sbit(int fd,unsigned char device_id,unsigned int func,unsigned int reg_addr,unsigned char inbit)
{
	return 0;
}

int write_nbits(int fd,unsigned char device_id,unsigned int func,unsigned int reg_addr,
				unsigned char *inbits,unsigned int length)
{
	return 0;
}

int write_sword(int fd,unsigned char device_id,unsigned int func,unsigned int reg_addr,
				unsigned char *inword)
{
	return 0;
}

int write_nwords(int fd,unsigned char device_id,unsigned int func,unsigned int reg_addr,
				 unsigned char *inwords,unsigned int length)
{
	return 0;
}

unsigned int ev_plc_write ( PLC_DRV_REG_ADDR * reg_addr , PLC_DRV_BUFF * buff, PLC_DRV_INIT_SETTINGS *settings )
{
	return 0;
}

unsigned int ev_plc_driver_info (PLC_DRV_INFO * info)
{
	info->driver_no=23;
	info->version=1.0;
}

void Delay(int ms)
{
	usleep(ms*1000);
}

int ReadData(int fd, unsigned char *read_buff, int count, int ms)
{
		int res,nread;
		fd_set rfds;
		struct timeval timeout;
		
		FD_ZERO(&rfds);
		FD_SET(fd, &rfds);
		timeout.tv_sec = 0;
		timeout.tv_usec = ms*1000;
		
		res=select(fd+1, &rfds, NULL, NULL, &timeout);
	
		if (res==0)
			return -1;
	
		if (res<0)
			return -2;
	
	return recv( fd, read_buff, count, 0 );
}

int WriteData(int fd, unsigned char *read_buff, int count)
{
	int nwrite;
	
	//nwrite=write(fd, read_buff ,count);
	//return nwrite;
	return send( fd, read_buff, count, 0 );	
}

int creat_udp_sockfd(void)
{
	return socket(AF_INET,SOCK_DGRAM,0);
}

void set_server_ip(struct sockaddr_in *server,char *str_ip,unsigned short port)
{	
	server->sin_family = AF_INET;
	server->sin_addr.s_addr =inet_addr(str_ip);
	server->sin_port=htons(port);//default_port
}

int ev_recvfrom(int sockfd, char *buf,  unsigned int len,int ms,struct sockaddr *from)
{
	socklen_t addrlen;
	int res,nread;
	fd_set rfds;
	struct timeval timeout;
	
	FD_ZERO(&rfds);
	FD_SET(sockfd, &rfds);
	timeout.tv_sec = 0;
	timeout.tv_usec = ms*1000;
	
	res=select(sockfd+1, &rfds, NULL, NULL, &timeout);

	if (res==0){
		printf("timeout\r\n");
		return -1;
	}
	
	if (res<0){
		printf("other error\r\n");
		return -2;
	}
	return recvfrom( sockfd, buf, len, 0,from,&addrlen);
}

int ev_sendto(int sockfd, char *buf,  unsigned int len,struct sockaddr *to)
{
	return sendto( sockfd, buf, len, 0, to, sizeof(struct sockaddr));
}
int SetupConnect(char net_type, char *str_ip, unsigned short port)
{
    int socketfd = -1;//׽
    struct sockaddr_in server; //׽ֵַṹ
    unsigned char ip_temp_buffer[5] = {0};//洢 ip address
    char ip_buff[20] = {0};//洢 IP buffer
    char ip_temp[5] = {0};//ipʱ
    int i;
    short Enternet_mode;

    server.sin_family = AF_INET;
    server.sin_addr.s_addr = inet_addr(str_ip);
    server.sin_port = htons(port); //default_port
    if ( net_type )
        Enternet_mode = SOCK_STREAM;//TCP connection
    else
        Enternet_mode = SOCK_DGRAM;//UDP connection
    socketfd = socket(AF_INET, Enternet_mode, 0); //׽ֲӷ
    if (socketfd < 0) {
        printf("socket error\r\n");
        return (-1);
    }
    struct timeval timeo;
    socklen_t len = sizeof(timeo);
    timeo.tv_sec =  3;  //timeout2%10 ⲿֱʾsocketĳʱ
    timeo.tv_usec = 0;
    int option = 1;
    while ( 1 ) {
        setsockopt(socketfd, SOL_SOCKET, SO_SNDTIMEO, &timeo, len);
        setsockopt(socketfd, SOL_SOCKET, SO_REUSEADDR, &option, sizeof(option));
        if ( connect(socketfd, (void *)&server, sizeof(server)) < 0 ) {
            close(socketfd);
            socketfd = socket(AF_INET, Enternet_mode, 0); //׽ֲӷ
            if (socketfd < 0) {
                printf("socket error\r\n");
                return (-1);
            }
            printf("connect error\r\n");
            continue;
        }
        break;
    }
    return socketfd;
}

void ev_close_handel(int sockfd)
{
	close(sockfd);
}
void LockShm(void)//get sem
{
    struct sembuf sops;
    sops.sem_num = 0;
    sops.sem_op = -1;
    sops.sem_flg = 0;
    semop(globle_semid, &sops, 1);
}
void unLockShm(void)//release sem
{
    struct sembuf sops;
    sops.sem_num = 0;
    sops.sem_op = 1;
    sops.sem_flg = 0;
    semop(globle_semid, &sops, 1);
}

unsigned short Read_LW(unsigned int n)
{
    unsigned short temp=0;

     if(n>LW_READ_MAX)
        return ;
    LockShm();
    temp = (*(unsigned short*)LW_addr(n));
    unLockShm();
    return temp;
}
void Write_LW(unsigned int n,unsigned short val)
{
    if(n>LW_WRITE_MAX)
        return ;
    LockShm();
    (*(unsigned short*)LW_addr(n)) = val;
    unLockShm();
}
void CopyToLW(unsigned int offset,const void *src, int n)
{
	if(offset+((n+1)/2)>LW_WRITE_NUM_MAX)
        return;
	LockShm();
	memcpy(LW_addr(offset) ,src,n);
	unLockShm();
}
void CopyFromLW(unsigned int offset,const void *src, int n)
{
	if(offset+((n+1)/2)>LW_READ_NUM_MAX)
        return;
	LockShm();
	memcpy((void *)src,LW_addr(offset),n);
	unLockShm();
}

void SetLBON(unsigned int n)
{
   if(n>LB_WRITE_MAX)
        return;
    LockShm();
    globle_local_bit[(n/32)]|=(1<<(n%32));
    unLockShm();
}

void SetLBOFF(unsigned int n)
{
	if(n>LB_WRITE_MAX)
        return;
    LockShm();
   globle_local_bit[(n/32)]&=(~(1<<(n%32)));
    unLockShm();
}

int GetLB(unsigned int n)
{
	int temp;
	
	if(n>LB_READ_MAX)
        return -1;
	LockShm();
   if((globle_local_bit[(n/32)]>>(n%32))&1 == 1)
   	temp = 1;
   else
   	temp = 0;
    unLockShm();
	return temp;
}

int SetLWBON(unsigned int n, unsigned int offset)
{
	if(n>LW_WRITE_MAX || offset>15)
        return -1;
    LockShm();
    local_short[n]|=(1<<offset);
    unLockShm();
}

int SetLWBOFF(unsigned int n, unsigned int offset)
{
	if(n>LW_WRITE_MAX || offset>15)
        return -1;
    LockShm();
    local_short[n]&=(~(1<<offset));
    unLockShm();
}

int GetLWB(unsigned int n, unsigned int offset)
{
	int temp;
	if(n>LW_READ_MAX || offset>15)
        return -1;
	
	LockShm();
   if((local_short[n]>>offset)&1 == 1)
   	temp = 1;
   else
   	temp = 0;
    unLockShm();
	return temp;
}

unsigned int ev_plc_slave_main (short plc_slave_id, int * local_bit, short * local_word, int semid ,PLC_DRV_INIT_SETTINGS * settings)
{	
	
	int cycle_time=0;
	int ms;
	
	globle_semid = semid;
	globle_local_bit = local_bit;
	local_short = local_word;
	while(1)
	{
	
		ProcessComx(settings->serial_handle);

	}
}

void Pthread_cr(void *(*threaddeal)(void *))
{
	 void *status;
	 pthread_t tidp;
	 tidp = pthread_self();
	 pthread_create(&tidp, NULL, threaddeal, NULL);
}

int Read_Rw( void *buf, int addr, int nWords )
{
  int ret = -1;
  int fd = open( "/dev/sram-mmap", O_RDWR );
  if((addr+nWords)>130500)return ret;  
  if ( fd > 0 )
  {
    lseek( fd, 0x400+addr*2, 0 );
    ret = read( fd, buf, nWords*2);
    close( fd );
  }
  return ret;
}

int Write_Rw( void *buf, int addr, int nWords )
{
  int ret = -1;
  int fd = open( "/dev/sram-mmap", 1 );
  if((addr+nWords)>130500)return ret;  
  if ( fd > 0 )
  {
    lseek( fd, 0x400+addr*2, 0 );
    ret = write( fd, buf, nWords*2);
    close( fd );
  }
  return ret;
}
