/********************************************************************
  Copyright (C), 2005, eView HMItek (Shanghai) Ltd.
  All rights reserved.
  
  FileName: plc_driver.h
  Description:    PLC driver interface
  				ͨѶӿͷļ˱׼Ľӿڶͻĺ궨
  				ЭֻҪļ޸
  				Э鲻ͬдͬplc_driver.cļ޸ıļ
       
  Revision history:         
      <author>  <time>   <version >   <desc>
      maxt    2005/3/30  0.1         build this program
      maxt    2005/4/18  0.3         ev_plc_init()

********************************************************************/

#define VERSION_A 0
#define VERSION_B 0
#define VERSION_C 1

enum _PLC_DRV_RETURN_CODE {plc_drv_success,plc_drv_send_error,plc_drv_timeout,plc_drv_select_error,plc_drv_range_out,plc_drv_checksum_error,plc_drv_buff_full};
typedef enum _PLC_DRV_RETURN_CODE PLC_DRV_RETURN_CODE;


/*ȫֽṹ ****************************************/
//ڳʼϢṹ
typedef struct {
        char *com_device; //ĳʼִָ
        int baud; // plain baud rate
        unsigned char parity;     // 0 for none, 1 for odd, 2 for even   
        unsigned char data_bits;
        unsigned char stop_bits;
        unsigned char mode; //ʽ485 2W, 4W, 232
  } PLC_SERIAL_INIT_PARAMETERS;

/*2 PLC_DRV_INIT_SETTINGS
ڳʼṹ
³ʼϢ*/
typedef  struct {
int serial_handle;  //˿ļָ
unsigned short  mode; //ʽ485 2W, 4W, 232
unsigned short  driver_id; //PLCѡһԴļɶPLC
unsigned int response_timeout;  //ȫֳʱʱ䣬Ӧʱ
unsigned int timeout1;//ȴӦʱ䣬ӵE5Ӧʱ䣬MODBUS1.5ָ֡ʱ
unsigned int timeout2; //Ӧʱ2
} PLC_DRV_INIT_SETTINGS;


/* 2 PLC_DRV_REG_ADDR
ַϢ
PLCֺţĴַͣӵַ*/
typedef struct
{
unsigned short device_id;  //豸ֺ
unsigned char reg_type;   //Ĵַݿͣ0bit , 1-byte, 2-word, 4-dword
unsigned char reg_id;   //PLCĳݿ͵Ĳַͬ,3X,4Xû
unsigned int reg_addr;   //ַ
unsigned short sub_addr;  //ӵַ
unsigned short reserved;   //
}PLC_DRV_REG_ADDR;

// 3 PLC_DRV_BUFF
//Ϣ£*/
typedef struct 
{
unsigned int length; 
unsigned char * buff;
}PLC_DRV_BUFF;

// 4 PLC_DRV_INFO
//򷵻Ϣ
typedef struct
{
unsigned short driver_no;  //
unsigned short version;
}PLC_DRV_INFO;

unsigned int ev_plc_init( PLC_SERIAL_INIT_PARAMETERS * serial_settings,PLC_DRV_INIT_SETTINGS * settings);
unsigned int ev_plc_read ( PLC_DRV_REG_ADDR * reg_addr , PLC_DRV_BUFF * buff ,  PLC_DRV_INIT_SETTINGS * settings);
unsigned int ev_plc_write ( PLC_DRV_REG_ADDR * reg_addr , PLC_DRV_BUFF * buff, PLC_DRV_INIT_SETTINGS * settings );
unsigned int ev_plc_driver_info (PLC_DRV_INFO * info);
unsigned int ev_plc_slave_main (short plc_slave_id, int * local_bit, short * local_word, int semid, PLC_DRV_INIT_SETTINGS * settings);

