#include     <stdio.h>      /*±ê×¼ÊäÈëÊä³ö¶¨Òå*/
#include     <stdlib.h>     /*±ê×¼º¯Êý¿â¶¨Òå*/
#include     <unistd.h>     /*Unix ±ê×¼º¯Êý¶¨Òå*/
#include     <sys/types.h>
#include     <sys/stat.h>
#include     <fcntl.h>      /*ÎÄ¼þ¿ØÖÆ¶¨Òå*/
#include     <termios.h>    /*PPSIX ÖÕ¶Ë¿ØÖÆ¶¨Òå*/
#include     <errno.h>      /*´íÎóºÅ¶¨Òå*/
#include 	 <sys/time.h>
#include	 <time.h>
#include     <stdbool.h>
#include     <sys/sem.h>

void Delay(int ms);
int ReadData(int fd, unsigned char *read_buff, int count, int ms);
int WriteData(int fd, unsigned char *read_buff, int count);
unsigned short Read_LW(unsigned int n);
void Write_LW(unsigned int n, unsigned short val);
void CopyToLW(unsigned int offset, const void *src, int n);
void CopyFromLW(unsigned int offset, const void *src, int n);
void SetLBON(unsigned int n);
void SetLBOFF(unsigned int n);
int GetLB(unsigned int n);
int SetLWBON(unsigned int n, unsigned int offset);
int SetLWBOFF(unsigned int n, unsigned int offset);
int GetLWB(unsigned int n, unsigned int offset);
int set_sp_speed(int fd, int nSpeed);

#define TIMEOUT 100		//100ms
#define LW_addr(n)   (local_short+(n))

extern short *local_short;
void LockShm(void);
void unLockShm(void);

static void _CopyToLW(unsigned int offset,const void *src, int n)
{
	// if(offset+((n+1)/2)>LW_WRITE_NUM_MAX)
 //        return;
	LockShm();
	memcpy(LW_addr(offset) ,src,n);
	unLockShm();
}

static unsigned short _Read_LW(unsigned int n)
{
    unsigned short temp=0;

     // if(n>LW_READ_MAX)
     //    return ;
    LockShm();
    temp = (*(unsigned short*)LW_addr(n));
    unLockShm();
    return temp;
}

void ProcessComx(int fd)
{
	unsigned int ch=0;
	// int timeout;
	// unsigned int len_rev = 0;
	int ret = 0;
	// int frame_ok = 1;
	// unsigned int retry = 0;
	// double weight = 0;

	ret	= ReadData(fd, (unsigned char *)&ch, 1, TIMEOUT);
	if (ret > 0) {
		//todo: 通知GUI，收到按键:  LW9528~9529
		_CopyToLW(9528, &ch,sizeof(unsigned int));
		// printf("%s get a key %s\r\n", __func__,&ch);
		// printf("LW9528 = 0x%x\r\n", _Read_LW(9528));
		// printf("LW9529 = 0x%x\r\n", _Read_LW(9529));
		Delay(10);
	}else{
		// printf("%s nothing: %d\r\n", __func__,ret);
		// Delay(100);
	}
}
